<?php
/**
* @version $Id: mosimage.php,v 1.15 2004/09/28 14:21:30 stingrey Exp $
* @package Mambo_4.5.1
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_MAMBOTS->registerFunction( 'onPrepareContent', 'botMosRelated' );

/**
*/
function botMosRelated( $published, &$row, &$params, $page=0  ) {
	global $database, $my, $mainframe; 

	$query = "SELECT id FROM #__mambots WHERE element = 'mosrelated' AND folder = 'content'";
	$database->setQuery( $query );
	$mid = $database->loadResult();
	$mambot = new mosMambot( $database );
	$mambot->load( $mid );
	$mparams =& new mosParameters( $mambot->params );

	$head      = trim ( $mparams->get( 'header', 'Related news' ) );
	$pos       = trim ( $mparams->get( 'location', 'right' ) );
	$vpos      = trim ( $mparams->get( 'vloc', 'top' ) );
	$usetag    = trim ( $mparams->get( 'usetag', 'no' ) );
	$css_class = trim ( $mparams->get( 'class', '' ) );
	$tblwidth  = trim ( $mparams->get( 'tablewidth', '200' ) );
	
	$regex = "#{mosrelated}#s";


    if (!$published || $params->get( 'popup' ) || $params->get( 'intro_only' )) {
  	  $row->text = preg_replace( $regex, '', $row->text );
	  return true;
	}
	
	// select the meta keywords from the item
	$id = $row->id;
	$query = "SELECT metakey FROM #__content WHERE id='$id'";
	$database->setQuery( $query );

    $html = '';

	if ($metakey = trim( $database->loadResult() )) {
		// explode the meta keys on a comma
		$keys = explode( ',', $metakey );
		$likes = array();

		// assemble any non-blank word(s)
		foreach ($keys as $key) {
			$key = trim( $key );
			if ($key) {
				$likes[] = $database->getEscaped( $key );
			}
		}

		if (count( $likes )) {
			// select other items based on the metakey field 'like' the keys found
			$query = "SELECT id, title"
			. "\nFROM #__content"
			. "\nWHERE id<>$id AND state=1 AND access <= $my->gid AND (metakey LIKE '%";
			$query .= implode( "%' OR metakey LIKE '%", $likes );
			$query .= "%')";

			$database->setQuery( $query );
			if ($related = $database->loadObjectList()) {
			    $html .= "<table width=\"$tblwidth\" align=\"$pos\" border=\"0\" cellspacing=\"0\" cellpadding=\"1\" class=\"$css_class\">\n";
				  if (!empty($head)) {
				    $html .= "<tr><td><b>$head</b></td></tr>\n";
					}
				foreach ($related as $item) {
					if ($option="com_content" && $task="view") {
						$Itemid = $mainframe->getItemid($item->id);
					}
					$href = sefRelToAbs( "index.php?option=com_content&task=view&id=$item->id&Itemid=$Itemid" );
					$html .= "<tr><td> <li> <a href=\"$href\">$item->title</a></li></td></tr>\n";
				}
				$html .= "</table>\n";
			}
		}
	}
	
	if ($usetag == "yes") 
      $row->text = preg_replace( $regex, $html, $row->text );
	else {
      $row->text = preg_replace( $regex, '', $row->text );
	  if ($vloc == "top")
    	  $row->text = $html.$row->text;
	  else
	      $row->text .= $html;
	}
	
	return true;
	
}



?>
